include:
- local: cargo.yml

.scripts:
  copy-pages:
  - mkdir -p ${CI_PROJECT_DIR}/public
  - cp -R target/doc/* ${CI_PROJECT_DIR}/public
  redirect: |
    if [[ -n "$REDIRECT_FROM" ]]; then
      echo "/${REDIRECT_FROM}/index.html /"${REDIRECT_TO}" 302" >> ${CI_PROJECT_DIR}/public/_redirects
      echo "/${REDIRECT_FROM}/ /${REDIRECT_TO} 302" >> ${CI_PROJECT_DIR}/public/_redirects
    fi

docs:
  extends: .cargo
  script:
  - cargo clippy --all-targets --all-features -- -D missing_docs -D warnings
  stage: test

pages:
  extends: .cargo
  script:
  - RUSTDOCFLAGS="-Dwarnings" cargo doc --workspace --no-deps --all-features
  - !reference [.scripts, copy-pages]
  - !reference [.scripts, redirect]
  rules: !reference [.rules, on-deploy]
  artifacts:
    paths:
    - ${CI_PROJECT_DIR}/public

pages-dev:
  extends: .cargo
  needs:
  - docs
  script:
  - RUSTDOCFLAGS="-Dwarnings" cargo doc --workspace --no-deps --all-features
  - !reference [.scripts, copy-pages]
  - !reference [.scripts, redirect]
  artifacts:
    paths:
    - ${CI_PROJECT_DIR}/public
